;-----------------------------------------------------------------------------------------------
; Overview of Main Functions
;-----------------------------------------------------------------------------------------------
;
; CS-HAEARTH - earth hatch 
;
; CS-HAROCK - rock hatch
;
;-----------------------------------------------------------------------------------------------

(defun C:cs-HAEARTH ()
  (if (wcmatch (getvar 'acadver) "*Brics*")
    (kd-hatch "EARTH1" 0.5 45)
    (kd-hatch "EARTH" 0.5 45)
  )    ;if
)      ;defun
(defun c:CS-HAROCK ()
  (if (wcmatch (getvar 'acadver) "*Brics*")
    (kd-hatch "GRAVEL1" 0.25 0)
    (kd-hatch "GRAVEL" 0.25 0)
  )    ;if
)      ;defun

(DEFUN kd-hatch (pattern scale rotation / cmdecho clayer doc ent entname)
  (defun *error* (msg)
    (if (not (member msg '( "Function cancelled" "quit / exit abort")))
      (princ (strcat "\nError: " msg))
    )  ;if
    (vla-endundomark doc)
    (if cmdEcho (setvar 'cmdecho cmdEcho))
    (if clayer (setvar 'clayer clayer))
    (princ)
  )    ;defun *error*
  
  (vla-startundomark (setq doc (vla-get-activedocument (vlax-get-acad-object))))
  
  (setq cmdEcho (getvar 'cmdecho))
  (setvar 'cmdEcho 0)
  
  (SETQ clayer (GETVAR "CLAYER"))
  ;IF LAYER DOES NOT EXIST MAKE THE LAYER THEN SET THE LAYER TO CURRENT
  (IF (NOT (TBLSEARCH "LAYER" "HATCH"))
    (COMMAND "LAYER" "M" "HATCH" "C" "252" "" "" "")
    (IF (NOT (= "HATCH" CLAYER))
      (SETVAR "CLAYER" "HATCH")
    );IF
  );IF

  (setq ent (car (entsel)))
  (setq entname (entget ent))
  (ENTMOD (subst (cons 8 "DEFPOINTS") (assoc 8 entname) entname))
  
  (COMMAND "-HATCH" "P" pattern scale rotation "S" ENT "" "") 
  
  (setvar "clayer" clayer)
  (setvar 'cmdEcho cmdEcho)
  (vla-endundomark doc)
  (princ)
)      ;defun

